package yrpg.application.crmvisit.plugin.form;

import kd.bos.bill.MobileBillShowParameter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.plugin.AbstractMobFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

/**
 * 动态表单插件(移动端)
 * 新增专家-弹框
 */
public class ExpertPopupMobFormPlugin extends AbstractMobFormPlugin implements Plugin {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("yrpg_btnok");
    }

    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control)evt.getSource();
        String key = source.getKey();
        if (key.equals("yrpg_btnok")){
            String expertNum = String.valueOf(this.getModel().getValue("yrpg_expertnum")).trim();
            if(expertNum.isEmpty()){
                this.getView().showTipNotification("请填写执业证书编号");
            }else{
                QFilter filter = new QFilter("yrpg_expert_number", QCP.equals, expertNum);
                DynamicObject expertBase = QueryServiceHelper.queryOne("yrpg_yzj_expert_base", "id,name", filter.toArray());
                if (expertBase!=null){
                    //申请维护人界面
                    showMobileForm("yrpg_relationship_bind_mob",null);
                }else {
                    //新增专家界面,携带证书编号
                    showMobileForm("yrpg_yzj_expert_base_mob",expertNum);
                }
            }
        }
    }

    private void showMobileForm(String formId,String expertNum){
        MobileBillShowParameter showParameter = new MobileBillShowParameter();
        showParameter.setFormId(formId);
        if (expertNum!=null){
            showParameter.setCustomParam("expertNum",expertNum);
        }
        showParameter.getOpenStyle().setShowType(ShowType.Floating);
        this.getView().showForm(showParameter);
    }
}